%
%                            Copyright 2011 Zilmar de Souza Junior,
%						                    Marcos Moecke 
%
%
%
%    ModuloOperacoes is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    ModuloOperacoes is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with ModuloOperacoes. If not, see <http://www.gnu.org/licenses/>.
%
function varargout = ModuloOperacoes(varargin)
% MODULOOPERACOES M-file for ModuloOperacoes.fig
%      MODULOOPERACOES, by itself, creates a new MODULOOPERACOES or raises the existing
%      singleton*.
%
%      H = MODULOOPERACOES returns the handle to a new MODULOOPERACOES or the handle to
%      the existing singleton*.
%
%      MODULOOPERACOES('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MODULOOPERACOES.M with the given input arguments.
%
%      MODULOOPERACOES('Property','Value',...) creates a new MODULOOPERACOES or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ModuloOperacoes_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ModuloOperacoes_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ModuloOperacoes

% Last Modified by GUIDE v2.5 24-Nov-2014 19:19:34

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ModuloOperacoes_OpeningFcn, ...
                   'gui_OutputFcn',  @ModuloOperacoes_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ModuloOperacoes is made visible.
function ModuloOperacoes_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ModuloOperacoes (see VARARGIN)

% Choose default command line output for ModuloOperacoes
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes ModuloOperacoes wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = ModuloOperacoes_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in checkboxReverter.
function checkboxReverter_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxReverter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxReverter

% --- Executes on selection change in popupmenuSelecaoSinal.
function popupmenuSelecaoSinal_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuSelecaoSinal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenuSelecaoSinal contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuSelecaoSinal


% --- Executes during object creation, after setting all properties.
function popupmenuSelecaoSinal_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuSelecaoSinal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbuttonPlotar.
function pushbuttonPlotar_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonPlotar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.metricdata.escalar = str2double(get(handles.editMultiplicarEscalar, 'String'));
handles.metricdata.deslocar = str2double(get(handles.editDeslocarTempo,'String'));
Atualiza_ModuloOperacoes(handles)


function editMultiplicarEscalar_Callback(hObject, eventdata, handles)
% hObject    handle to editMultiplicarEscalar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editMultiplicarEscalar as text
%        str2double(get(hObject,'String')) returns contents of editMultiplicarEscalar as a double
escalar = str2double(get(hObject, 'String'));
if isnan(escalar)
    set(hObject, 'String', 0);
    errordlg('Intervalo invlido','Error');
end
% Save the new intervalo value
handles.metricdata.escalar = escalar;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function editMultiplicarEscalar_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editMultiplicarEscalar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editDeslocarTempo_Callback(hObject, eventdata, handles)
% hObject    handle to editDeslocarTempo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editDeslocarTempo as text
%        str2double(get(hObject,'String')) returns contents of editDeslocarTempo as a double
deslocar = str2double(get(hObject, 'String'));
if isnan(deslocar)
    set(hObject, 'String', 0);
    errordlg('Intervalo invlido','Error');
end
% Save the new intervalo value
handles.metricdata.deslocar = deslocar;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function editDeslocarTempo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editDeslocarTempo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenuSinal1.
function popupmenuSinal1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuSinal1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenuSinal1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuSinal1


% --- Executes during object creation, after setting all properties.
function popupmenuSinal1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuSinal1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenuSinal2.
function popupmenuSinal2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuSinal2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenuSinal2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuSinal2


% --- Executes during object creation, after setting all properties.
function popupmenuSinal2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuSinal2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbuttonAplicarOp.
function pushbuttonAplicarOp_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonAplicarOp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbuttonAplicarOpS.
function pushbuttonAplicarOpS_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonAplicarOpS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



% --------------------------------------------------------------------
function zoomx_OffCallback(hObject, eventdata, handles)
% hObject    handle to zoomx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom on;

% --------------------------------------------------------------------
function zoomx_OnCallback(hObject, eventdata, handles)
% hObject    handle to zoomx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom xon;


% --------------------------------------------------------------------
function zoomy_OffCallback(hObject, eventdata, handles)
% hObject    handle to zoomy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom on;

% --------------------------------------------------------------------
function zoomy_OnCallback(hObject, eventdata, handles)
% hObject    handle to zoomy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom yon;


% --------------------------------------------------------------------
function expandir_ClickedCallback(hObject, eventdata, handles)
% hObject    handle to expandir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


prompt = {'Qual sinal expandir?'};
titulo_janela = 'Expandir';
num_linhas = 1;
default={'1'};
qualsinal = inputdlg(prompt,titulo_janela,num_linhas,default);
qualsinal = str2double(cat(2,qualsinal{:}));
switch qualsinal
    case 1
        set(handles.axes1,'XLim',[-10 10])
    case 2
        set(handles.axes2,'XLim',[-10 10])
    case 3
        set(handles.axes3,'XLim',[-10 10])
end


% 
% function FreqSinal1_Callback(hObject, eventdata, handles)
% % hObject    handle to freqSinal1 (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
% 
% % Hints: get(hObject,'String') returns contents of freqSinal1 as text
% %        str2double(get(hObject,'String')) returns contents of freqSinal1 as a double



function FreqSinal1_Callback(hObject, eventdata, handles)
% hObject    handle to FreqSinal1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

freqSinal1 = str2double(get(hObject, 'String'));
if isnan(freqSinal1)
    set(hObject, 'String', 0);
    errordlg('Valor invlido','Error');
end
if freqSinal1 > 1e3
    errordlg('Valor mximo permitido  1000 Hz. Assumindo valor mximo.','Erro');
    freqSinal1 = 1e3;
end
% Save the new intervalo value
handles.metricdata.freqSinal1 = freqSinal1;
guidata(hObject,handles)


% --- Executes during object creation, after setting all properties.
function FreqSinal1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FreqSinal1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FreqSinal2_Callback(hObject, eventdata, handles)
% hObject    handle to FreqSinal2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
freqSinal2 = str2double(get(hObject, 'String'));
if isnan(freqSinal2)
    set(hObject, 'String', 0);
    errordlg('Valor invlido','Error');
end
if freqSinal2 > 1e3
    errordlg('Valor mximo permitido  1000 Hz. Assumindo valor mximo.','Erro');
    freqSinal2 = 1e3;
end
% Save the new intervalo value
handles.metricdata.freqSinal2 = freqSinal2;
guidata(hObject,handles)


% --- Executes during object creation, after setting all properties.
function FreqSinal2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FreqSinal2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbuttonSinal1.
function pushbuttonSinal1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonSinal1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[handles.tipoSinal1,handles.freqSinal1,handles.vSinal1,handles.bsinc1,handles.fullPath1]=MenuModulante;
while handles.tipoSinal1==6
    uiwait(errordlg('Uso de arquivos de som no est disponvel para este mdulo','Erro','modal'));
    [handles.tipoSinal1,handles.freqSinal1,handles.vSinal1,handles.bsinc1,handles.fullPath1]=MenuModulante;
end
guidata(hObject, handles);


% --- Executes on button press in pushbuttonSinal2.
function pushbuttonSinal2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonSinal2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[handles.tipoSinal2,handles.freqSinal2,handles.vSinal2,handles.bsinc2,handles.fullPath2]=MenuModulante;
while handles.tipoSinal2==6
    uiwait(errordlg('Uso de arquivos de som no est disponvel para este mdulo','Erro','modal'));
    [handles.tipoSinal2,handles.freqSinal2,handles.vSinal2,handles.bsinc2,handles.fullPath2]=MenuModulante;
end
guidata(hObject, handles);
