%
%                            Copyright 2011 Zilmar de Souza Junior,
%						                    Marcos Moecke 
%
%
%
%    Atualiza_Interface is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    Atualiza_Interface is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with Atualiza_Interface. If not, see <http://www.gnu.org/licenses/>.
%

function [mod,s] = Atualiza_Interface_am(handles)
%% Usando o valor de senoide defina na interface

%global handles;
%if(get(handles.radiobuttonManual,'Value')==1)
if 1
    %% Calculos para determinar a portadora, modulante e o sinal modulado
    % Intervalo = 1:
    dur=1;
    % Frequencia de amostragem:
    fs=1e5;    
    % Periodo de amostragem:
    Ts = 1/fs;        
    %Frequencia da portadora
    fp = handles.metricdata.freqp;    
    %Frequencia da modulante
    fm = handles.freqm;   
    % V de pico da portadora
    vpp = handles.metricdata.vpico;   
    % V de pico da modulante
    vmp = handles.vmodulante;   
    % beta para sinc
    bsinc = handles.bsinc;    
    % Indice de modula��o
    m= handles.metricdata.m;
    
    % Modulante    
    modulante=handles.modulante; %Recebe a func�o do menu;
    if(modulante ~= 6) % Continua caso modulante no seja um arquivo
        % Vetor tempo:
        t= -dur : Ts : dur - Ts;
        % Cria��o Vetor Frequ�ncia
        df = (1 / (2*dur)) / 16;
        f = -fs/2 : df : fs/2-df;
        
        mod=DefineMod(modulante,vmp,fm,t,bsinc);
    else % Modulante por arquivo
        [mod,dur,t,df,f]=DefineModAudio(handles.fullPath,fs,Ts,dur);
    end
    
    % Portadora
    p = vpp*cos(2*pi*fp.*t);
    
    % Sinal modulado:
    s = (m*mod + 1) .* p;
    
    % plota a portadora no plot correspondente com a cor vermelha:
    plot(handles.axes_port,t,p,'k');
    a = get(handles.axes_port,'YLim');
    set(handles.axes_port,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
    if(modulante==6)
        set(handles.axes_port,'XLim',[0 dur])%[-2*2*pi/fp 2*2*pi/fp])
    else
        set(handles.axes_port,'XLim',[-1/fp 1/fp])%[-2*2*pi/fp 2*2*pi/fp])
    end
    set(handles.axes_port,'XGrid','on')
    set(handles.axes_port,'YGrid','on')
    
    % plota a modulante no plot correspondente com a cor padrao (azul):
    plot(handles.axes_mod,t,mod);
    a = get(handles.axes_mod,'YLim');
    set(handles.axes_mod,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
    if(modulante==6)
        set(handles.axes_mod,'XLim', [0 dur])
    else
        set(handles.axes_mod,'XLim', [-3/fm 3/fm])%[-2*2*pi/fp 2*2*pi/fp])
    end
    set(handles.axes_mod,'XGrid','on')
    set(handles.axes_mod,'YGrid','on')
    
    % plota o sinal modulado no plot correspondente com a cor preta:
    plot(handles.axes_sign,t,s,'k');
    a = get(handles.axes_sign,'YLim');
    set(handles.axes_sign,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
    %equivalente do hold on para plotar a envoltoria:
    set(handles.axes_sign,'NextPlot','add');
    %plota modulante sobre o sinal modulado:
    plot(handles.axes_sign,t,(vpp).*(1+(m*mod)),'b');
    %equivalente do hold off:
    set(handles.axes_sign,'NextPlot','replace');
    if(modulante==6)
        set(handles.axes_sign,'XLim', [0 dur])
    else
        set(handles.axes_sign,'XLim', [-1/fm 1/fm])%[-2*2*pi/fp 2*2*pi/fp])
    end
    set(handles.axes_sign,'XGrid','on')
    set(handles.axes_sign,'YGrid','on')
    
    % valor do eixo omega usado no plot do sinal modulado no dominio da
    % transformada de fourier do sinal
    SINAL = fftshift(fft(s, length(f)))/fs;    
    plot(handles.axes_freq,f,abs(SINAL));
    a = get(handles.axes_freq,'YLim');
    set(handles.axes_freq,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
    set(handles.axes_freq,'XLim',[-(log(fp))*fm-fp fp+(log(fp))*fm])
    xlabel('Frequ�ncia [Hz]');
    ylabel('Amplitude');     
    axes(handles.axes_port)
    xlabel('Tempo [s]');
    ylabel('Amplitude');
    axes(handles.axes_mod)
    xlabel(gca,'Tempo [s]');
    ylabel(gca,'Amplitude');
    axes(handles.axes_sign)
    xlabel('Tempo [s]');
    ylabel('Amplitude');
    axes(handles.axes_freq)
    xlabel('Frequ�ncia [Hz]');
    ylabel('Amplitude');
    clc
    
    
    
    
else
    %% Usando voz gravada no microfone
    t = handles.metricdata.t;
    x_Voz_adq = handles.metricdata.d; % voz adquirida
    fa_Voz = 8000;
    fa_Sys = 4 *fa_Voz;
    
    x_Voz_norm = x_Voz_adq/(max(abs(x_Voz_adq)));
    
    % Fazendo uma sobreamostragem e interpola��o:
    x_Voz_interp = fdesign.pulseshaping(x_Voz_norm,fa_Voz,fa_Sys,'fir');
    
    % Sinal modulante:
    x_mod = x_Voz_interp;
    
    t = linspace(min(t),max(t),length(x_mod))';
    if isfield(handles,'metricdata')
        if isfield(handles.metricdata,'freqp')
            fpd = handles.metricdata.freqp;
        else
            fpd=1000;
        end
    else
        fpd=1000;
    end
    
    % limita a freq da portadora a 1/3 da fs/2
    fp = min(1/20/(t(2)-t(1)),fpd);
    set(handles.c_freqp,'String',fp);
    
    % V de pico da portadora
    if isfield(handles,'metricdata')
        if isfield(handles.metricdata,'vpico')
            vpp = handles.metricdata.vpico;
        else
            vpp=1;
        end
    else
        vpp=1;
    end
    % Indice de modula��o
    if isfield(handles,'metricdata')
        if isfield(handles.metricdata,'m')
            ind_mod= handles.metricdata.m;
        else
            ind_mod = 1;
        end
    else
        ind_mod=1;
    end
        
    x_port=vpp*cos(2*pi*fp.*t);
    y_AM=(((ind_mod*x_mod)+1)).*x_port;
        
    cTF = 1024;
    y_AM_z = cat(1,y_AM,zeros(ceil(length(y_AM)/cTF)*cTF-length(y_AM),1));
    M_y_AM_z =reshape(y_AM_z,cTF, length(y_AM_z)/cTF);
    Y_AM_z = fftshift(fft(M_y_AM_z,cTF,1));
    Y = abs(Y_AM_z);
    axes(handles.axes_freq)
    mesh(Y(:,:));
    ax_freq = [-4 : 4]*cTF/8;
    set(handles.axes_freq,'YTick',ax_freq+cTF/2);
    set(handles.axes_freq,'YTickLabel',ax_freq'/(cTF/2)*fa_Sys/2);
    
    
    plot(handles.axes_port,t,x_port,'r');
    plot(handles.axes_mod,t,x_Voz_interp);
    plot(handles.axes_sign,t,y_AM,'k');
    %equivalente do hold on
    set(handles.axes_sign,'NextPlot','add');
    %plota modulante sobre o sinal modulado
    plot(handles.axes_sign,t,(vpp.*((ind_mod*x_Voz_interp)+1)),'b');
    %equivalente do hold off
    set(handles.axes_sign,'NextPlot','replace');
    
    set(handles.axes_port,'XLim',[0 3/fp])
    set(handles.axes_mod,'XLim',[0 max(t)])
    set(handles.axes_sign,'XLim',[0 2*2*pi/fp])
    % Calcular 64 como sendo um round ceil do fmod+fmax_voz
    mfDF = 512;
    set(handles.axes_freq,'YLim',[-mfDF mfDF]+cTF/2)
    set(handles.axes_port,'XGrid','on')
    set(handles.axes_port,'YGrid','on')
    set(handles.axes_mod,'XGrid','on')
    set(handles.axes_mod,'YGrid','on')
    set(handles.axes_sign,'XGrid','on')
    set(handles.axes_sign,'YGrid','on')
    a = get(handles.axes_port,'YLim');
    set(handles.axes_port,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
    a = get(handles.axes_mod,'YLim');
    set(handles.axes_mod,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
    a = get(handles.axes_sign,'YLim');
    set(handles.axes_sign,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
    clc
end

end