%
%                            Copyright 2011 Zilmar de Souza Junior,
%						                    Marcos Moecke
%
%
%
%    Atualiza_ModuloBasico is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    Atualiza_ModuloBasico is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with Atualiza_ModuloBasico. If not, see <http://www.gnu.org/licenses/>.
%

function Atualiza_ModuloBasico(handles)

if(get(handles.RBContinuo,'Value')==1)
    %% --- Sinal contnuo --- %%
    % O cdigo abaixo  responsvel pela representao do sinal na
    % forma contnua.
    fa = handles.metricdata.freqAmostragem;
    x = 1;
    valPico = handles.vSinal;
    freqSinal = handles.freqSinal;
    bsinc = handles.bsinc;
    f = freqSinal;
    
    Ta = 1/fa; % Periodo de amostragem;
    t=[-(x):Ta:(x)-Ta]; % vetor tempo
    
    
    % Seleo da funo escolhida pelo usurio
    funcao = handles.tipoSinal;
       if(funcao ~= 6)
        % Vetor tempo:
        t= -x : Ta : x - Ta;
        % Cria��o Vetor Frequ�ncia
        df = (1 / (2*x)) / 16;
        wb = -fa/2 : df : fa/2-df;
        
        y=DefineMod(funcao,valPico,freqSinal,t,bsinc);
       else
        [y,x,t,df,wb]=DefineModAudio(handles.fullPath,fa,Ta,x);
       end
    
    
    % --- Domnio do tempo --- %
    % plota o sinal:
    plot(handles.axes1,t,y); 
    
    % atribui ttulo, nome ao eixo X e Y, define escala do eixo X e
    % habilita o grid:
    title(handles.axes1,'Sinal no domnio do tempo') 
    xlabel(handles.axes1,'Tempo [s]')
    ylabel(handles.axes1,'Amplitude')
    set(handles.axes1,'XLim',[-1/f 1/f])
    set(handles.axes1,'XGrid','on')
    set(handles.axes1,'YGrid','on')
    a = get(handles.axes1,'YLim');
    %Limites do eixo y:
    set(handles.axes1,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
    
    % --- Domnio da frequencia --- %
    Y = fftshift(fft(y, length(wb)))/fa;    
    plot(handles.axes2,wb,abs(Y));
    % define titulo, nomes para o eixo X e Y e tamanho da escala de Y:
    title(handles.axes2,'Sinal no domnio da frequncia')
    xlabel(handles.axes2,'Frequncia [Hz]')
    ylabel(handles.axes2,'Amplitude')
    a = get(handles.axes2,'YLim');
    set(handles.axes2,'XLim',[-(log(f))*f-f f+(log(f))*f])
    %Limites do eixo y:
    set(handles.axes2,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
    set(handles.axes2,'XGrid','on')
    set(handles.axes2,'YGrid','on')
    clc
    
else
    %% --- Sinal Discreto --- %%
    % O cdigo abaixo  responsvel pela representao do sinal na forma
    % discreta.
    
    fa = handles.metricdata.freqAmostragem;
    freqSinal = handles.freqSinal;
    f = freqSinal;
    x=1;
    valPico = handles.vSinal;
    bsinc = handles.bsinc;
    n=-20:20; % Numero de amostras;
    Ta = 1/fa; % Periodo de amostragem;
    t=[-(x):Ta:(x)-Ta]; % vetor tempo
    funcao = handles.tipoSinal;
       if(funcao ~= 6)
        % Vetor tempo:
        t= -x/20 : Ta : x/20 - Ta;
        % Cria��o Vetor Frequ�ncia
        df = (1 / (2*x)) / 16;
        wb = -fa/2 : df : fa/2-df;
        
        y=DefineMod(funcao,valPico,freqSinal,t,bsinc);
    else
        [y,x,t,df,wb]=DefineModAudio(handles.fullPath,fa,Ta,x);
    end
    
    % --- Domnio do tempo --- %
    stem(handles.axes1,t,y) % representa o sinal no grfico atravs da funo stem
    title(handles.axes1,'Sinal no domnio do tempo')
    xlabel(handles.axes1,'Tempo [s]')
    ylabel(handles.axes1,'Amplitude')
    set(handles.axes1,'XGrid','on')
    set(handles.axes1,'YGrid','on')
    a = get(handles.axes1,'YLim');
    %Limites do eixo y:
    set(handles.axes1,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
    
    Y = fftshift(fft(y, length(wb)))/fa;    
    plot(handles.axes2,wb,abs(Y));
    
    % define titulo, nomes para o eixo X e Y e tamanho da escala de Y:
    title(handles.axes2,'Sinal no domnio da frequncia')
    xlabel(handles.axes2,'Frequncia [Hz]')
    ylabel(handles.axes2,'Amplitude')
    a = get(handles.axes2,'YLim');
    set(handles.axes2,'XLim',[-(log(f))*f-f f+(log(f))*f])
    %Limites do eixo y:
    set(handles.axes2,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
    set(handles.axes2,'XGrid','on')
    set(handles.axes2,'YGrid','on')
    clc
    
end