%
%                            Copyright 2011 Zilmar de Souza Junior,
%						                    Marcos Moecke 
%
%
%
%    Atualiza_ModuloOperacoes is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    Atualiza_ModuloOperacoes is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with Atualiza_ModuloOperacoes. If not, see <http://www.gnu.org/licenses/>.
%

function Atualiza_ModuloOperacoes(handles)

%% Importao das variveis

% Valores padro;
escalar = 1;
deslocar = 0;
reverter=1;

%% Valores bsicos
fa=1e5;
x = 10;
Ta = 1/fa; % Periodo de amostragem;
t=[-(x):Ta:(x)-Ta];
%chama as funes para os sinais 1 e 2:
calculaSinal1(reverter,escalar,deslocar); 
calculaSinal2(reverter,escalar,deslocar);
%% Tipo sinal 1:
    function calculaSinal1(reverter,escalar,deslocar)
        f=handles.freqSinal1; % pega a frequencia que o usuario escolheu
        tipoSinal1 = handles.tipoSinal1; % pega a funo do sinal escolhida pelo usuario
        bsinc = handles.bsinc1;
        switch tipoSinal1
            case 1
                sinal1=escalar*sin(2*pi*f.*(reverter*t-deslocar));
            case 2
                sinal1=escalar*cos(2*pi*f.*(reverter*t-deslocar));
            case 3
                sinal1=escalar*sinc(2*pi*f.*(reverter*t-deslocar));
            case 4
                sinal1=escalar*u((reverter*t-deslocar));
            case 5
                sinal1=escalar*square(2*pi*f.*(reverter*t-deslocar));
        end
    end
%% Tipo sinal 2:
    function calculaSinal2(reverter,escalar,deslocar)
        f=handles.freqSinal2; % pega a frequencia que o usuario escolheu
        tipoSinal2 = handles.tipoSinal2; % pega a funo do sinal escolhida pelo usuario
        bsinc = handles.bsinc2;
        switch tipoSinal2
            case 1
                sinal2=escalar*sin(2*pi*f.*(reverter*t-deslocar));
            case 2
                sinal2=escalar*cos(2*pi*f.*(reverter*t-deslocar));
            case 3
                sinal2=escalar*sinc(2*bsinc.*(reverter*t-deslocar));
            case 4
                sinal2=escalar*u((reverter*t-deslocar));
            case 5
                sinal2=escalar*square(2*pi*f.*(reverter*t-deslocar));
        end
    end
%% Operaes

    function reverter = checaReversao
        if (get(handles.checkboxReverter,'Value')==0)
            % No h reverso temporal
            reverter = 1;
        else
            % H reverso temporal
            reverter = -1;
        end
    end

if(get(handles.popupmenuSelecaoSinal,'Value')==1)
    % Operao sobre o sinal 1
    escalar = handles.metricdata.escalar;
    deslocar = handles.metricdata.deslocar;
    reverter = checaReversao;
    calculaSinal1(reverter,escalar,deslocar);
    
else
    % Operao sobre o sinal 2
    escalar = handles.metricdata.escalar;
    deslocar = handles.metricdata.deslocar;
    reverter = checaReversao;
    calculaSinal2(reverter,escalar,deslocar);
end
%% Operaes entre sinais
if(get(handles.radiobuttonMultiplicar,'Value')==1)
    % multiplicao dos sinais
    sinal3 = sinal1.*sinal2;
else
    sinal3 = sinal1+sinal2;
end
%% Plot dos sinais:

% --- Domnio do tempo --- %
f2=handles.freqSinal2;
f1=handles.freqSinal1;
% Sinal 1:
plot(handles.axes1,t,sinal1,'LineWidth',1.5);
set(handles.axes1,'XLim',[-1/f2 1/f2])
set(handles.axes1,'XGrid','on')
set(handles.axes1,'YGrid','on')
axes(handles.axes1)
title('Sinal 1')
xlabel('Tempo [s]')
ylabel('Amplitude')
a = get(handles.axes1,'YLim');
%Limites do eixo y:
set(handles.axes1,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])

% Sinal 2:
plot(handles.axes2,t,sinal2,'LineWidth',1.5);
set(handles.axes2,'XLim',[-1/f2 1/f2])
set(handles.axes2,'XGrid','on')
set(handles.axes2,'YGrid','on')
axes(handles.axes2)
title('Sinal 2')
xlabel('Tempo [s]')
ylabel('Amplitude')
a = get(handles.axes2,'YLim');
%Limites do eixo y:
set(handles.axes2,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])

% Sinal 3:
plot(handles.axes3,t,sinal3,'LineWidth',1.5);
set(handles.axes3,'XLim',[-1/f2 1/f2])
set(handles.axes3,'XGrid','on')
set(handles.axes3,'YGrid','on')
axes(handles.axes3)
title('Sinal 3')
xlabel('Tempo [s]')
ylabel('Amplitude')
a = get(handles.axes3,'YLim');
%Limites do eixo y:
set(handles.axes3,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
clc
end