%
%                            Copyright 2011 Zilmar de Souza Junior,
%						                    Marcos Moecke
%
%
%
%    EvalModulo is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    EvalModulo is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with EvalModulo. If not, see <http://www.gnu.org/licenses/>.
%

function EvalModulo(handles)
if(get(handles.RBContinuo,'Value')==1)
    % Carrega os parametros bsicos pra funo inserida no eval
    fs = handles.metricdata.freqSinal;
    str = handles.metricdata.campoEval;
    n = 1;
    fa= handles.metricdata.freqAmostragem;
    
    Ta = 1/fa;
    t=[-(n):Ta:(n)-Ta];
    
    sinal = eval(str); % A funo passsada pelo usurio  processada pela funo eval e tem o resultado salvo em sinal
    lf=length(t); % tamanho do vetor t salvo em lf
    freq=fft(sinal,lf); % Calculo da FFT
    wb = linspace(-fa/2,fa/2,lf); % cria vetor frequencia wb com tamnanho lf e limites entre -fa/2 e fa/2

    
    % Plota os sinais nos grficos
    
    plot(handles.axes1,t,sinal);
    title(handles.axes1,'Sinal no domnio do tempo') 
    xlabel(handles.axes1,'Tempo [s]')
    ylabel(handles.axes1,'Amplitude')
    set(handles.axes1,'XLim',[-1/fs 1/fs])
    set(handles.axes1,'XGrid','on')
    set(handles.axes1,'YGrid','on')
    a = get(handles.axes1,'YLim');
    set(handles.axes1,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
  
    
    % Plota o sinal no domnio da frequncia.
    lf=length(t); % tamanho do vetor t salvo em lf
    freq=fft(sinal,lf); % Calculo da FFT
    wb = linspace(-fa/2,fa/2,lf); % cria vetor frequencia wb com tamnanho lf e limites entre -fa/2 e fa/2
    plot(handles.axes2,wb,abs(fftshift(freq))/lf)
    title(handles.axes2,'Sinal no domnio da frequncia')
    xlabel(handles.axes2,'Frequncia [Hz]')
    ylabel(handles.axes2,'Amplitude')
    a = get(handles.axes2,'YLim');
    set(handles.axes2,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
    set(handles.axes2,'XLim',[-2*fs 2*fs])
    set(handles.axes2,'XGrid','on')
    set(handles.axes2,'YGrid','on')
    
else
 % Carrega os parametros bsicos pra funo inserida no eval
    fs = handles.metricdata.freqSinal;
    str = handles.metricdata.campoEval;
    N = 10;
    fa= handles.metricdata.freqAmostragem;
    
    n=[-(N):(N)];
    sinal = eval(str); % A funo passsada pelo usurio  processada pela funo eval e tem o resultado salvo em sinal
    lf=length(n);
    freq=fft(sinal,lf); % Calculo da FFT
    
    % Plota os sinais nos grficos
    stem(handles.axes1,n,sinal);  
    set(handles.axes1,'XGrid','on')
    set(handles.axes1,'YGrid','on')
    a = get(handles.axes1,'YLim');
    set(handles.axes1,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
    wb = linspace(-fs/2,fs/2,lf);
    plot(handles.axes2,wb,abs(fftshift(freq))/lf)
    a = get(handles.axes2,'YLim');
    set(handles.axes2,'YLim', [a(1)-(a(2)-a(1))*.1 a(2)+(a(2)-a(1))*.1])
end